//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                class FArray
//

#ifndef _FArray_Appeared_
#define _FArray_Appeared_

#include <string.h>

template <class TYPE>
class FArray
{
//˽ݺ˽к
protected:
    void **data;
    unsigned int count;

    //ͷŶռõڴ
    void release();
public:
//ϵͳú벻Ҫע

    FArray(){count=0;}
    FArray(FArray<TYPE> &other);
    virtual ~FArray(){Clear();}

//

    TYPE &operator[](unsigned int index){return *(TYPE *)data[index];}
    FArray &operator =(FArray<TYPE> &other);
    bool operator > (FArray<TYPE> &other){return count> other.count;}
    bool operator < (FArray<TYPE> &other){return count< other.count;}
    bool operator ==(FArray<TYPE> &other){return count==other.count;}

//ûӿڷ

    //ȡԪظ
    unsigned int GetCount(void){return count;}
    //Ԫ
    bool Swap(unsigned int count1,unsigned int count2);
    //ӿԪ
    bool AddEmpty(void);
    //Ԫ
    bool Add(TYPE member);
    //Ԫ
    bool InsertEmpty(unsigned int index);
    //Ԫأǰ壩
    bool Insert(TYPE member,unsigned int index);
    //ɾԪ
    bool Delete(unsigned int index);
    //ɾȫԪ
    bool Clear(void);
};

//¸ǽӿڵľʵ֣ûбҪ˽ǵ
//ֻҪгĽӿڲʹǾ
//ĻǾ

//˽к

template <class TYPE>
void FArray<TYPE>::release()
{
    if(count)
        delete(data);
}

//ϵͳú벻Ҫע

template <class TYPE>
FArray<TYPE>::FArray(FArray<TYPE> &other)
{
    data=NULL;
    count=0;
    operator =(other);
}

//
template <class TYPE>
FArray<TYPE> &FArray<TYPE>::operator =(FArray<TYPE> &other)
{
    if(count)
        Clear();

    if(other.GetCount()==0)
        count=0;
    else
    {
        for(unsigned int i=0; i<other.GetCount(); i++)
            Add(other[i]);
    }

    return *this;
}

//ûӿڷ
//Ϊ˱֤Ժ޸ģҽЩķֵΪbool
//ʵЩʲôҲ

template <class TYPE>
bool FArray<TYPE>::Swap(unsigned int count1,unsigned int count2)
{
    void *tmp;

    tmp=data[count1];
    data[count1]=data[count2];
    data[count2]=tmp;

    return true;
}

template <class TYPE>
bool FArray<TYPE>::Add(TYPE member)
{
    AddEmpty();
    *((TYPE *)data[count-1])=member;
    return true;
}

template <class TYPE>
bool FArray<TYPE>::AddEmpty(void)
{
    void **tmp;

    tmp=new void*[count+1];

    if(count)
        memcpy(tmp,data,count*sizeof(void*));

    tmp[count]=new TYPE;

    release();

    count++;
    data=tmp;

    return true;
}

template <class TYPE>
bool FArray<TYPE>::Insert(TYPE member,unsigned int index)
{
    if(index>=count)
        return Add(member);

    InsertEmpty(index);
    *((TYPE*)data[index])=member;
    return true;
}

template <class TYPE>
bool FArray<TYPE>::InsertEmpty(unsigned int index)
{
    if(index>=count)return AddEmpty();

    void **tmp;

    if(!(tmp=new void*[count+1]))return false;

    if(index)
        memcpy(tmp,data,index*sizeof(void*));

    tmp[index]=new TYPE;

    memcpy(tmp+index+1,data+index,(count-index)*sizeof(void*));

    release();

    count++;
    data=tmp;

    return true;
}

template <class TYPE>
bool FArray<TYPE>::Delete(unsigned int index)
{
    if(index>count-1)
        return false;

    void **tmp;

    if(!(tmp=new void*[count-1]))return false;

    if(index)
        memcpy(tmp,data,index*sizeof(void*));

    memcpy(tmp+index,data+index+1,(count-index-1)*sizeof(void*));

    release();

    count--;
    data=tmp;

    return true;
}

template <class TYPE>
bool FArray<TYPE>::Clear(void)
{
    for(unsigned int i=0;i<count;i++)
        delete data[i];

    release();
    count=0;

    return true;
}

#endif
